100 REMark convert ASCII Z88 Pipedream database files to Archive Import ASCII file format
110 REMark Z88 database should have field headings in line 1 of the document, but this is optional as the user can change these or append his/her own
120 REMark the fields/columns in Pipedream separated by TAB characters, code 9
130 REMark the end of line codes should be LF (10) only, translated on transfer using QZ
140 REMark runs in BASIC only on JS or later QL's when Z88 line length>127 characters due to INPUT bug in BASIC, OK when compiled.
150 IF COMPILED THEN 
160   OPEN#0,'con_484x42a14x214':OPEN#1,'scr_484x202a14x13'
170   WHEN_ERROR 0
180     BEEP 5000,70:PRINT#0,'Oops, error ';ERNUM%;' at line ';ERLIN%
190     PRINT#0,'PRESS ANY KEY TO CONTINUE.':PAUSE
200     PRINT#0,'Retry (y/n)?';:IF YN$=='y' THEN RETRY:ELSE STOP:END IF 
210   END_WHEN
220 END IF 
230 DIM z88$(40),ql$(40),ip$(1024),op$(1024),f$(255),entry$(255),k$(2):k$=''
240 MODE 4:WINDOW#0,484,42,14,214:WINDOW 484,202,14,13
250 BORDER#0,1,4:BORDER 1,4
260 PAPER 0:INK 7:CLS:PAPER#0,0:INK#0,7:CLS#0:CURSOR_ON#0!
270 OVER 1:CSIZE 3,1:x=0
280 FOR char=2,2,2,7:CURSOR 78+x,33+(x/1.5):INK char:PRINT'PIPEDREAM TO ARCHIVE':x=x+1
290 FOR char=2,2,2,7:CURSOR 86+x,88+(x/1.5):INK char:PRINT'DATAFILE CONVERSION':x=x+1
300 FOR char=2,2,2,7:CURSOR 38+x,143+(x/1.5):INK char:PRINT'BY DILWYN JONES JUNE 1988':x=x+1
310 PRINT#0,'CONVERT ASCII PIPEDREAM DATAFILE FROM Z88 TO QL ARCHIVE IMPORT FORMAT'
320 CSIZE 0,0
330 REPeat loop
340   PRINT#0,'Enter filename to convert:';:TYPE_IN FILL$(CHR$(192),4)
350   z88$=EDIT$(#0,'flp1__z88',40):CURSOR_ON#0!
360   IF z88$='' THEN EXIT loop
370   z88_fer=DEVICE_STATUS(1,z88$)
380   IF z88_fer<0 THEN BEEP 5000,70:PRINT#0,"Can't load that file!":NEXT loop
390   EXIT loop
400 END REPeat loop
410 IF z88$='' THEN PRINT#0,\'End of program.':STOP
420 OPEN_IN#3,z88$
430 REPeat loop
440   PRINT#0,'Enter output filename:';:TYPE_IN FILL$(CHR$(192),4)
450   ql$=EDIT$(#0,'flp1__exp',40):CURSOR_ON#0!
460   IF ql$='' THEN EXIT loop
470   ql_fer=DEVICE_STATUS(ql$)
480   IF ql_fer=-8 THEN 
490     BEEP 5000,70:PRINT#0,'Already exists. Delete (y/n)?';
500     IF YN$=='y' THEN DELETE ql$:ql_fer=DEVICE_STATUS(ql$):ELSE NEXT loop:END IF 
510   END IF 
520   IF ql_fer<0 THEN BEEP 5000,70:PRINT#0,"Can't save that file!":NEXT loop
530   EXIT loop
540 END REPeat loop
550 IF ql$='' THEN PRINT#0,\'End of program.':STOP
560 OPEN_NEW#4,ql$
570 CLS#0:PRINT#0,'Converting ';z88$!'to'!ql$;'...'
580 REMark are column headings present in first line of file?
590 INPUT#3,ip$:REMark get first line of Z88 file
600 CLS:PRINT ip$:PRINT#0,'The first line of the Z88 database file is shown above. Is it column headings'\'(y/n, if not it will be treated as a part of the data)?';
610 IF YN$=='y' THEN 
620   REMark extract number of columns
630   PRINT#0,'Extracting column details...':columns=0:widest=0:col_width=0
640   FOR char=1 TO LEN(ip$)
650     col_width=col_width+1
660     IF ip$(char)=CHR$(9) THEN 
670       columns=columns+1
680       IF col_width>widest THEN widest=col_width
690       col_width=0
700     END IF 
710   NEXT char
720     columns=columns+1:PRINT#0,columns;' columns.'
730     IF col_width>widest THEN widest=col_width
740     col_width=0
750   END FOR char
760   IF columns=1 THEN 
770     BEEP 5000,70:PRINT#0,'Only 1 column. Are you sure this is a database file (y/n)?';
780     IF YN$=='n' THEN PRINT#0,'PROGRAM FINISHED.':STOP
790   END IF 
800   DIM fnm$(columns,widest),type%(columns)
810   REMark fnm$ contains field names to be extracted from first line or entered by user
820   REMark type% contains type of column (1=string, 2=numeric, 0=unset)
830   start_pos=1:REMark subscript to start search for field name
840   field_no=0:REMark field being done, starts from 1
850   REPeat extract_names
860     entry$='':field_no=field_no+1
870     IF field_no>columns THEN EXIT extract_names
880     FOR char=start_pos TO LEN(ip$)
890       IF ip$(char)=CHR$(9) THEN 
900         start_pos=char+1:REMark where next field starts
910         fnm$(field_no)=entry$:REMark put field name in list
920         EXIT char
930       END IF 
940       entry$=entry$&ip$(char)
950     NEXT char
960       fnm$(field_no)=entry$:REMark last field name
970     END FOR char
980   END REPeat extract_names
990   CLS:PRINT:PRINT'DATABASE FIELD NAMES EXTRACTED:'
1000   FOR char=1 TO columns:PRINT'(';char;') ';fnm$(char)
1010 ELSE 
1020   REMark first Pipedream line is not headings, it's data
1030   SET_POSITION#3,0:REMark reset file position after initial test read
1040   REMark use first line read to work out number of columns
1050   columns=0:widest=255:REMark whatever pipedream widest columns are
1060   FOR char=1 TO LEN(ip$)
1070     IF ip$(char)=CHR$(9) THEN columns=columns+1
1080   NEXT char
1090     columns=columns+1:PRINT#0,columns;' columns.'
1100   END FOR char
1110   DIM fnm$(columns,widest),type%(columns)
1120   FOR char=1 TO columns
1130     PRINT#0,'Enter name of field ';char;'/';columns;':';
1140     fnm$(char)=EDIT$(#0,'',255):CURSOR_ON#0!
1150     PRINT'(';char;') ';fnm$(char)
1160   END FOR char
1170 END IF 
1180 REMark the following routine services both above routines
1190 CLS#0:PRINT#0,'Translate all fields as text (y/n)?';:all_text%=1
1200 IF YN$=='y' THEN 
1210   all_text%=1
1220   FOR char=1 TO columns:type%(char)=1
1230 ELSE 
1240   FOR char=1 TO columns
1250     PRINT#0,'Field ';char;'= <';fnm$(char);'>: Treat as text (y/n)?';
1260     IF YN$=='y' THEN type%(char)=1:ELSE type%(char)=0:all_text%=0:END IF 
1270   END FOR char
1280 END IF 
1290 REMark output: send field data
1300 FOR char=1 TO columns
1310   PRINT#4,'"';fnm$(char);
1320   IF type%(char)=1 THEN PRINT#4,'$';:REMark string field definition for Archive import file
1330   PRINT#4,'"';
1340   IF char<columns THEN PRINT#4,',';:ELSE PRINT#4,CHR$(10);:END IF 
1350 END FOR char
1360 records=0
1370 PRINT#0,'Converting'!z88$!'to'!ql$;'...':PRINT\'CONVERTED RECORDS:':PRINT:REMark restore old prompt
1380 REPeat read_records
1390   IF EOF(#3) THEN EXIT read_records
1400   IF INKEY$=CHR$(27) THEN EXIT read_records
1410   INPUT#3,ip$:REMark get one pipedream record
1420   posn=1:REMark current character in ip$
1430   FOR field=1 TO columns
1440     IF posn<=LEN(ip$) THEN 
1450       FOR char=posn TO LEN(ip$)
1460         IF ip$(char)=CHR$(9) THEN 
1470           REMark non-last field
1480           IF posn=char THEN f$='':ELSE f$=ip$(posn TO char-1):END IF 
1490           posn=char+1:EXIT char
1500         END IF 
1510       NEXT char
1520         REMark last field
1530         f$=ip$(posn TO LEN(ip$)):posn=char+1
1540       END FOR char
1550     ELSE 
1560       f$='':REMark create a null field
1570     END IF 
1580     IF type%(field)=1 THEN 
1590       PRINT#4,'"';f$;'"';:PRINT '"';f$;'"';:REMark send string unmodified
1600     ELSE 
1610       IF f$='' THEN f$='0'
1620       ok%=1:REMark check numeric field
1630       REMark check for non-leading minus
1640       IF ('-' INSTR f$)>1 THEN ok%=0
1650       dot='.' INSTR f$
1660       IF dot>0 AND dot<LEN(f$) THEN 
1670         IF '.' INSTR f$(dot+1 TO LEN(f$)) THEN ok%=0
1680       END IF 
1690       IF f$=='e' THEN ok%=0
1700       IF f$(1)=='e' OR f$(LEN(f$))=='e' THEN ok%=0
1710       IF ok%=1 THEN 
1720         ees=0
1730         FOR char=1 TO LEN(f$)
1740           IF (f$(char)<'0' OR f$(char)>'9') AND f$(char)<>'-' AND f$(char)<>'.' THEN ok%=0:EXIT char
1750           IF f$(char)=='e' THEN ees=ees+1:IF ees>1 THEN ok%=0:EXIT char:END IF 
1760         END FOR char
1770       END IF 
1780       IF ok%=0 THEN 
1790         CLS#0:PRINT#0,'Numeric field - Please amend this entry if necessary:';
1800         f$=EDIT$(#0,f$,255):CURSOR_ON#0!
1810         PRINT#0,'Converting'!z88$!'to'!ql$;'...':REMark restore old prompt
1820       END IF 
1830       PRINT#4,f$;:PRINT f$;:REMark unquoted numeric field
1840     END IF 
1850     IF field<columns THEN PRINT#4,',';:PRINT',';:ELSE PRINT#4,:PRINT:END IF 
1860   END FOR field
1870   records=records+1
1880 END REPeat read_records
1890 PRINT#4,CHR$(26);:REMark import file eof marker
1900 CLOSE#3:CLOSE#4:PRINT#0,\records;' records converted, end of program.'
1910 STOP
1920 DEFine FuNction YN$
1930   LOCal k$(2),loop
1940   REPeat loop
1950     k$=INKEY$(-1):IF k$='Y' THEN k$='y'
1960     IF k$='N' THEN k$='n'
1970     IF k$='y' OR k$='n' THEN PRINT#0,k$:EXIT loop
1980   END REPeat loop : RETurn k$
1990 END DEFine YN$
